; .

    include elips.inc


.code
start:

    invoke GlobalAlloc,GMEM_ZEROINIT,ShagSetki*16
    mov hmem,eax
    mov edi,eax
    lea edx,[eax+16]
    fild fsg
    fld1
    fst dword ptr [edi]
    fdivrp st(1),st(0)
    fldz
    mov ecx,ShagSetki/2-1
mst01:
    add edi,12
    fadd st(0),st(1)
    fld1
    fld st(1)
    fmul st(0),st(0)
    fsubp st(1),st(0)
    fsqrt
    fdiv dword ptr [edi-12]
    fstp dword ptr [edi]
    dec ecx
    jnz mst01
    fstp dword ptr [edx]
    fldz
    mov ecx,ShagSetki/2-1
mst02:
    fadd st(0),st(1)
    fst dword ptr [edx]
    fadd st(0),st(1)
    fst dword ptr [edx+4]
    xor byte ptr [edx+7],080h
    add edx,12
    dec ecx
    jnz mst02
    sub esp,4
    fstp dword ptr [esp]
    fstp dword ptr [esp]
    add esp,4
    
    invoke GetModuleHandle,0
    mov edi,offset wc
    mov [edi-8],eax
    mov [edi.WNDCLASS].style,CS_HREDRAW or CS_VREDRAW or CS_OWNDC
    mov [edi.WNDCLASS].lpfnWndProc,offset MyProc
    mov [edi.WNDCLASS].hInstance,eax
    invoke LoadCursor,0,IDC_ARROW
    mov [edi.WNDCLASS].hCursor,eax
    mov [edi.WNDCLASS].lpszClassName,offset szClassName
    invoke RegisterClass,edi
    invoke	GetSystemMetrics,SM_CXSCREEN
    mov ebx,eax
    invoke	GetSystemMetrics,SM_CYSCREEN
    sub ebx,700
    sub eax,700
    shr ebx,1
    shr eax,1
    invoke CreateWindowExA,0,offset szClassName,offset szDisplayName,
           WS_OVERLAPPEDWINDOW or WS_CLIPSIBLINGS or WS_CLIPCHILDREN,
           ebx,eax,700,700,0,0,[edi-8],0
    mov [edi-4],eax
    invoke ShowWindow,eax,SW_SHOW
    invoke UpdateWindow,[edi-4]
    sub esp,sizeof MSG
    mov edi,esp
SLoop:
    invoke GetMessage,edi,0,0,0
    or eax,eax
    jz ELoop
    invoke TranslateMessage,edi
    invoke DispatchMessage,edi
    jmp SLoop
ELoop:
    mov eax,[edi.MSG].wParam
    add esp,sizeof MSG
    invoke ExitProcess,eax

RenderShar:
    invoke glPushMatrix
    invoke glCallList,1
    mov ebx,ShagSetki/2-1
    mov edi,hmem
mrs01:
    add edi,12
    invoke glScalef,[edi],[edi],fl1
    invoke glTranslatef,0,0,[edi+4]
    invoke glCallList,1
    invoke glTranslatef,0,0,[edi+8]
    invoke glCallList,1
    dec ebx
    jnz mrs01
    invoke glPopMatrix
    ret

RenderScene:
    invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
    invoke glMatrixMode,GL_MODELVIEW
    invoke glLoadIdentity
    invoke glPushMatrix
    push nol
    push nol
    push odin
    fild rtx
    fdiv fl20
    sub esp,4
    fstp dword ptr [esp]
    call glRotatef
    push 0
    push fl1
    push 0
    fild rty
    fdiv fl20
    sub esp,4
    fstp dword ptr [esp]
    call glRotatef
    push fl1
    push 0
    push 0
    fild rtz
    fdiv fl20
    sub esp,4
    fstp dword ptr [esp]
    call glRotatef

    invoke glScalef,pa1,pa2,pa3

    ;invoke glColor3f,0,fl1,0
    call RenderShar
    invoke glRotatef,fl90,0,fl1,0
    ;invoke glColor3f,fl1,0,0
    call RenderShar
    invoke glRotatef,fl90,fl1,0,0
    ;invoke glColor3f,0,0,fl1
    call RenderShar
    
    invoke glPopMatrix
    invoke SwapBuffers,hdc
    ret

MyProc PROC

    xor eax,eax
    pushad
    mov ebp,esp
    mov eax,[ebp+40]

    cmp eax,WM_PAINT
    jnz MPaint
    call RenderScene
    invoke ValidateRect,[ebp+36],0
    popad
    ret 16
MPaint:

    cmp eax,WM_MOUSEMOVE
    jnz MMouse
    cmp dword ptr [ebp+44],MK_LBUTTON
    jnz MDWP
    mov ax,[ebp+50]
    mov cx,kurx
    cmp ax,cx
    jz MM02
    mov kurx,ax
    jnc MM01
    add rtx,20
    cmp rtx,7200
    jc MM02
    sub rtx,7200
    jmp MM02
MM01:
    sub rtx,20
    jns MM02
    add rtx,7200
MM02:
    mov ax,[ebp+48]
    mov cx,kury
    cmp ax,cx
    jz MMEnd
    mov kury,ax
    jnc MM03
    add rty,20
    cmp rty,7200
    jc MMEnd
    sub rty,7200
MM03:
    sub rty,20
    jns MMEnd
    add rtx,7200
MMEnd:
    invoke InvalidateRect,[ebp+36],0,0
    jmp MDWP

MMouse:

    cmp eax,WM_CREATE
    jnz MCreate
    
    invoke GetDC,[ebp+36]
    mov hdc,eax
    mov ebx,eax
    mov edi,offset PixFrm
    mov [edi.PIXELFORMATDESCRIPTOR].nSize,sizeof PIXELFORMATDESCRIPTOR
    mov [edi.PIXELFORMATDESCRIPTOR].nVersion,1
    mov [edi.PIXELFORMATDESCRIPTOR].dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER
    mov [edi.PIXELFORMATDESCRIPTOR].iPixelType,PFD_TYPE_RGBA
    mov [edi.PIXELFORMATDESCRIPTOR].cColorBits,24
    mov [edi.PIXELFORMATDESCRIPTOR].cDepthBits,16
    mov [edi.PIXELFORMATDESCRIPTOR].iLayerType,PFD_MAIN_PLANE
    invoke ChoosePixelFormat,ebx,edi
    invoke SetPixelFormat,ebx,eax,edi
    invoke wglCreateContext,ebx
    mov odc,eax
    invoke wglMakeCurrent,ebx,eax
    invoke glClearColor,0,0,0,fl1
    invoke glColor3f,0,fl1,0
    sub esp,48
    mov edi,esp
    invoke GetClientRect,[ebp+36],edi
    invoke glViewport,0,0,[edi+8],[edi+12]
    invoke glMatrixMode,GL_PROJECTION
    invoke glLoadIdentity
    mov esi,offset koord
    cld
    mov ecx,12
    rep movsd
    call glOrtho
    invoke glMatrixMode,GL_MODELVIEW
    invoke glLoadIdentity
    ;invoke glEnable,GL_DEPTH_TEST
    ;invoke glFrontFace,GL_CW
    invoke glEnable,GL_CULL_FACE
    invoke glEnable,GL_POLYGON_SMOOTH

    invoke glNewList,1,GL_COMPILE
    invoke glBegin,GL_LINE_LOOP
    fild fip
    fldpi
    fldpi
    faddp st(1),st(0)
    fdivrp st(1),st(0)
    fldz
    mov edi,SizePoint
mCr01:
    fld st(0)
    fld st(0)
    fsin
    sub esp,8
    fstp dword ptr [esp]
    fcos
    fstp dword ptr [esp+4]
    fadd st(0),st(1)
    call glVertex2f
    dec edi
    jnz mCr01
    ffree st(1)
    ffree st(0)
    invoke glEnd
    invoke glEndList
    popad
    ret 16
MCreate:

    cmp eax,WM_DESTROY
    jnz MDestroy
    invoke glDeleteLists,1,1
    invoke gluDeleteQuadric,pObject
    invoke wglMakeCurrent,hdc,0
    invoke wglDeleteContext,odc
    invoke GlobalFree,hmem
    invoke ReleaseDC,[ebp+36],hdc
    invoke PostQuitMessage,0
    popad
    ret 16
MDestroy:
MDWP:
    popad
    invoke DefWindowProc,[esp+16],[esp+16],[esp+16],[esp+16]
    ret 16

MyProc endp
EndProg:
end start